#ifndef FEATUREFUNCTION__H
#define FEATUREFUNCTION__H

#include <map>
#include <string>
#include "Config.hpp"

class FeatureFunction
{
  using Representation = std::vector<std::size_t>;
  using Feature = std::function<Config::String(const Config &)>;

  private :

  std::map<std::string, Feature> features;
  std::map<Config::String, std::size_t> dictionary;

  private :

  const Feature & getOrCreateFeature(const std::string & name);

  public :

  FeatureFunction(const std::vector<std::string_view> & lines);
  Representation getRepresentation(const Config & config) const;
};

#endif
